/*
 * Project name:
     LCD_BT (Simple demo for the Bluetooth serial adapter board)
 * Copyright:
     (c) www.tigal.com, 2007.
 * Description:
     Demonstration of an LCD remote control application
     using the Bluetooth serial adapter board.
 * Test configuration:
     MCU:             PIC16F877A
     Dev.Board:       EasyPIC3
     Oscillator:      HS, 08.0000 MHz
     Ext. Modules:    LCD 2x16
     SW:              mikroC v6.0
 * NOTES:
     None.
*/

char text; // buffer for the received text
int count;

void BT_SetCableReplacement();

void main()
{
  count=0;

  LCD_Init(&PORTD);
  USART_init(9600);

  LCD_Cmd(LCD_CLEAR);
  //LCD_Cmd(LCD_CURSOR_OFF);
  LCD_Out(1,6,"EasyBT");

  BT_SetCableReplacement(); // disable all BT notifications

  LCD_Cmd(LCD_SECOND_ROW);
  LCD_Cmd(LCD_BLINK_CURSOR_ON);

  while (1) {
    if (USART_Data_Ready()) {
      if (count==0) {
        // Refresh display
        LCD_Out(2,1,"                ");
        LCD_Cmd(LCD_RETURN_HOME);
        LCD_Cmd(LCD_SECOND_ROW);
      }
      text = USART_Read();
      Lcd_Chr_Cp(text);
      USART_Write(text);
      count = (count+1)%16;     }
  }
}

void BT_SetCableReplacement()
{
  USART_Write(0x02);
  USART_Write(0x52);
  USART_Write(0x4E);
  USART_Write(0x01);
  USART_Write(0x00);
  USART_Write(0xA1);
  USART_Write(0x03);
  USART_Write(0x03);
}
